unit UMainFrm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, uADGUIxIntf, uADGUIxFormsWait, uADStanIntf, uADStanOption,
  uADStanError, uADPhysIntf, uADStanDef, uADStanPool, uADStanAsync, uADPhysManager,
  Vcl.StdCtrls, Data.DB, uADCompClient, uADPhysIB, uADCompGUIx, Vcl.ExtCtrls, uADDAptManager,
  FBMetaData;

type
  TMainFrm = class(TForm)
    Panel1: TPanel;
    lbParam1: TListBox;
    pParam1: TPanel;
    Panel3: TPanel;
    lbParam2: TListBox;
    pParam2: TPanel;
    bTables: TButton;
    bView: TButton;
    bFields: TButton;
    Label1: TLabel;
    bViewSource: TButton;
    Label2: TLabel;
    Label3: TLabel;
    bFieldsType: TButton;
    bPK: TButton;
    Label4: TLabel;
    dbDataBase: TADConnection;
    ADPhysIBDriverLink1: TADPhysIBDriverLink;
    ADGUIxWaitCursor1: TADGUIxWaitCursor;
    Label5: TLabel;
    bPKType: TButton;
    bExceptions: TButton;
    bGenerators: TButton;
    bIndex: TButton;
    lbl1: TLabel;
    bProcedures: TButton;
    bProcSource: TButton;
    lbl2: TLabel;
    procedure bTablesClick(Sender: TObject);
    procedure bViewClick(Sender: TObject);
    procedure bFieldsClick(Sender: TObject);
    procedure bViewSourceClick(Sender: TObject);
    procedure bFieldsTypeClick(Sender: TObject);
    procedure bPKClick(Sender: TObject);
    procedure bPKTypeClick(Sender: TObject);
    procedure bExceptionsClick(Sender: TObject);
    procedure bGeneratorsClick(Sender: TObject);
    procedure bIndexClick(Sender: TObject);
    procedure bProceduresClick(Sender: TObject);
    procedure bProcSourceClick(Sender: TObject);
  private
    FFDObj: TFBMDFireDAC;

    procedure Reset;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

var
  MainFrm: TMainFrm;

implementation

{$R *.dfm}

{ TMainFrm }

procedure TMainFrm.bExceptionsClick(Sender: TObject);
begin
  Reset;
  FFDObj.GetExceptions(lbParam1.Items, lbParam2.Items);
  pParam1.Caption := 'Exceptions';
  pParam2.Caption := 'Mensajes';
end;

procedure TMainFrm.bFieldsClick(Sender: TObject);
begin
  if lbParam1.ItemIndex = -1 then
  begin
    ShowMessage('Selecciona una tabla');
    Exit;
  end;

  lbParam2.Clear;
  FFDObj.GetTableFields(lbParam1.Items[lbParam1.ItemIndex], lbParam2.Items);
  pParam2.Caption := 'Campos de ' + lbParam1.Items[lbParam1.ItemIndex];
end;

procedure TMainFrm.bTablesClick(Sender: TObject);
begin
  Reset;
  FFDObj.GetTables(lbParam1.Items);
  pParam1.Caption := 'Tablas';
end;

procedure TMainFrm.bPKClick(Sender: TObject);
begin
  if lbParam1.ItemIndex = -1 then
  begin
    ShowMessage('Selecciona una tabla');
    Exit;
  end;

  lbParam2.Clear;
  FFDObj.GetPrimaryKeyFields(lbParam1.Items[lbParam1.ItemIndex], lbParam2.Items);
  pParam2.Caption := 'Campos PK tabla ' + lbParam1.Items[lbParam1.ItemIndex];
end;

procedure TMainFrm.bPKTypeClick(Sender: TObject);
var
  L1, L2: TStringList;
  i: Integer;
begin
  if lbParam1.ItemIndex = -1 then
  begin
    ShowMessage('Selecciona una tabla');
    Exit;
  end;

  L1 := TStringList.Create;
  L2 := TStringList.Create;
  try
    lbParam2.Clear;
    FFDObj.GetPrimaryKeyFields(lbParam1.Items[lbParam1.ItemIndex], L1, L2);
    for i:= 0 to L1.Count - 1 do
      lbParam2.Items.Add(L1[i] + ' - ' + L2[i]);
  finally
    FreeAndNil(L1);
    FreeAndNil(L2);
  end;
  pParam2.Caption := 'Campos PK tabla ' + lbParam1.Items[lbParam1.ItemIndex];
end;

procedure TMainFrm.bProceduresClick(Sender: TObject);
begin
  Reset;
  FFDObj.GetProcedures(lbParam1.Items);
  pParam1.Caption := 'Procedures';
end;

procedure TMainFrm.bProcSourceClick(Sender: TObject);
begin
  if lbParam1.ItemIndex = -1 then
  begin
    ShowMessage('Selecciona un procedure');
    Exit;
  end;

  lbParam2.Clear;
  FFDObj.GetProcedureSource(lbParam1.Items[lbParam1.ItemIndex], lbParam2.Items);
  pParam2.Caption := 'Procedure ' + lbParam1.Items[lbParam1.ItemIndex];
end;

procedure TMainFrm.bViewSourceClick(Sender: TObject);
begin
  if lbParam1.ItemIndex = -1 then
  begin
    ShowMessage('Selecciona una vista');
    Exit;
  end;

  lbParam2.Clear;
  FFDObj.GetViewSource(lbParam1.Items[lbParam1.ItemIndex], lbParam2.Items);
  pParam2.Caption := 'Vista ' + lbParam1.Items[lbParam1.ItemIndex];
end;

procedure TMainFrm.bFieldsTypeClick(Sender: TObject);
var
  L1, L2: TStringList;
  i: Integer;
begin
  if lbParam1.ItemIndex = -1 then
  begin
    ShowMessage('Selecciona una tabla');
    Exit;
  end;

  L1 := TStringList.Create;
  L2 := TStringList.Create;
  try
    lbParam2.Clear;
    FFDObj.GetTableFields(lbParam1.Items[lbParam1.ItemIndex], L1, L2);
    for i:= 0 to L1.Count - 1 do
      lbParam2.Items.Add(L1[i] + ' - ' + L2[i]);
  finally
    FreeAndNil(L1);
    FreeAndNil(L2);
  end;
  pParam2.Caption := 'Campos de ' + lbParam1.Items[lbParam1.ItemIndex];
end;

procedure TMainFrm.bGeneratorsClick(Sender: TObject);
begin
  Reset;
  FFDObj.GetGenerators(lbParam1.Items);
  pParam1.Caption := 'Generators';
end;

procedure TMainFrm.bIndexClick(Sender: TObject);
begin
  if lbParam1.ItemIndex = -1 then
  begin
    ShowMessage('Selecciona una tabla');
    Exit;
  end;

  lbParam2.Clear;
  FFDObj.GetIndex(lbParam1.Items[lbParam1.ItemIndex], lbParam2.Items);
  pParam2.Caption := 'ndices de ' + lbParam1.Items[lbParam1.ItemIndex];
end;

procedure TMainFrm.bViewClick(Sender: TObject);
begin
  Reset;
  FFDObj.GetViews(lbParam1.Items);
  pParam1.Caption := 'Vistas';
end;

constructor TMainFrm.Create(AOwner: TComponent);
const
  DB = 'Database=%sTESTDB.FDB';
begin
  inherited;

  lbParam1.Clear;
  lbParam2.Clear;
  dbDataBase.Params.Add(Format(DB, [IncludeTrailingPathDelimiter(ExtractFilePath(ParamStr(0)))]));
  dbDataBase.Connected := True;

  FFDObj := TFBMDFireDAC.Create(dbDataBase);
end;

destructor TMainFrm.Destroy;
begin
  if Assigned(FFDObj) then FreeAndNil(FFDObj);

  inherited;
end;

procedure TMainFrm.Reset;
begin
  lbParam1.Clear;
  lbParam2.Clear;
  pParam1.Caption := '';
  pParam2.Caption := '';
end;

end.
